import type { DCloneHTMLElement, DSize } from '../../utils/types';
import type { DFormControl } from '../form';
import React from 'react';
export interface DDateInputRef {
    updatePosition: () => void;
}
export interface DDateInputProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    children: (props: {
        date: [Date | null, Date | null];
        isFocus: [boolean, boolean];
        changeDate: (date: Date | [Date, Date]) => void;
        renderPopup: DCloneHTMLElement;
    }) => JSX.Element | null;
    dRef: {
        inputLeft?: React.ForwardedRef<HTMLInputElement>;
        inputRight?: React.ForwardedRef<HTMLInputElement>;
    } | undefined;
    dClassNamePrefix: string;
    dFormControl: DFormControl | undefined;
    dModel: Date | null | [Date, Date] | undefined;
    dFormat: string;
    dVisible: boolean | undefined;
    dPlacement: 'top' | 'top-left' | 'top-right' | 'bottom' | 'bottom-left' | 'bottom-right';
    dOrder: (date: [Date, Date]) => boolean;
    dPlaceholder: [string, string];
    dSuffix: React.ReactNode | undefined;
    dRange: boolean;
    dSize: DSize | undefined;
    dClearable: boolean;
    dDisabled: boolean;
    dInputRender: [DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>?, DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>?] | undefined;
    onModelChange: ((date: any) => void) | undefined;
    onVisibleChange: ((visible: boolean) => void) | undefined;
    onUpdatePanel: ((date: Date) => void) | undefined;
    afterVisibleChange: ((visible: boolean) => void) | undefined;
    onClear: (() => void) | undefined;
}
export declare const DDateInput: React.ForwardRefExoticComponent<DDateInputProps & React.RefAttributes<DDateInputRef>>;
