import type { DId, DSize } from '../../utils/types';
import type { DFormControl } from '../form';
import React from 'react';
export interface DRadioItem<V extends DId> {
    label: React.ReactNode;
    value: V;
    disabled?: boolean;
}
export interface DRadioGroupProps<V extends DId> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dFormControl?: DFormControl;
    dList: DRadioItem<V>[];
    dModel?: V | null;
    dName?: string;
    dDisabled?: boolean;
    dType?: 'outline' | 'fill';
    dSize?: DSize;
    dVertical?: boolean;
    onModelChange?: (value: V) => void;
}
export declare function DRadioGroup<V extends DId>(props: DRadioGroupProps<V>): JSX.Element | null;
