/// <reference types="react" />
import type { DCloneHTMLElement } from '../../utils/types';
import type { DFormControl } from '../form';
export interface DSliderProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dRef?: {
        inputLeft?: React.ForwardedRef<HTMLInputElement>;
        inputRight?: React.ForwardedRef<HTMLInputElement>;
    };
    dFormControl?: DFormControl;
    dModel?: number | [number, number];
    dMax?: number;
    dMin?: number;
    dStep?: number | null;
    dDisabled?: boolean;
    dMarks?: number | ({
        value: number;
        label: React.ReactNode;
    } | number)[];
    dVertical?: boolean;
    dReverse?: boolean;
    dRange?: boolean;
    dRangeMinDistance?: number;
    dRangeThumbDraggable?: boolean;
    dTooltipVisible?: boolean | [boolean?, boolean?];
    dCustomTooltip?: (value: number) => React.ReactNode;
    dInputRender?: [
        DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>?,
        DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>?
    ];
    onModelChange?: (value: any) => void;
}
export declare function DSlider(props: DSliderProps): JSX.Element | null;
