import type { DId, DSize } from '../../utils/types';
import React from 'react';
export interface DTabsRef {
    updateIndicator: () => void;
}
export interface DTabItem<ID extends DId> {
    id: ID;
    title: React.ReactNode;
    panel: React.ReactNode;
    disabled?: boolean;
    closable?: boolean;
}
export interface DTabsProps<ID extends DId, T extends DTabItem<ID>> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dList: T[];
    dActive?: ID;
    dPlacement?: 'top' | 'right' | 'bottom' | 'left';
    dCenter?: boolean;
    dType?: 'wrap' | 'slider';
    dSize?: DSize;
    onActiveChange?: (id: T['id'], item: T) => void;
    onAddClick?: () => void;
    onClose?: (id: T['id'], item: T) => void;
}
declare function Tabs<ID extends DId, T extends DTabItem<ID>>(props: DTabsProps<ID, T>, ref: React.ForwardedRef<DTabsRef>): JSX.Element | null;
export declare const DTabs: <ID extends DId, T extends DTabItem<ID>>(props: DTabsProps<ID, T> & React.RefAttributes<DTabsRef>) => ReturnType<typeof Tabs>;
export {};
