import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isNumber } from 'lodash';
import React, { useState } from 'react';
import { useImmer, useMount } from '@react-devui/hooks';
import { FileTwoTone } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { TTANSITION_DURING_BASE } from '../../utils';
import { DTransition } from '../_transition';
import { DProgress } from '../progress';
import { usePrefixConfig, useTranslation } from '../root';
export function DPicture(props) {
    const { children, dFileList, dDefaultActions, dActions, onRemove } = props;
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const [t] = useTranslation();
    const [removeUIDs, setRemoveUIDs] = useImmer([]);
    const [skipFirstTransition, setSkipFirstTransition] = useState(true);
    useMount(() => {
        setSkipFirstTransition(false);
    });
    return (_jsxs("ul", Object.assign({ className: `${dPrefix}upload__picture` }, { children: [dFileList.map((file, index) => {
                const actions = dActions(file, index);
                const isLoading = file && file.status === 'progress';
                return (_jsx(DTransition, Object.assign({ dIn: !removeUIDs.includes(file.uid), dDuring: TTANSITION_DURING_BASE, dSkipFirstTransition: skipFirstTransition, afterLeave: () => {
                        setRemoveUIDs((draft) => {
                            draft.splice(draft.findIndex((uid) => uid === file.uid), 1);
                        });
                        onRemove(file);
                    } }, { children: (state) => {
                        let transitionStyle = {};
                        switch (state) {
                            case 'enter':
                                transitionStyle = { transform: 'scale(0)' };
                                break;
                            case 'entering':
                                transitionStyle = {
                                    transition: ['transform'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
                                    transformOrigin: 'top left',
                                };
                                break;
                            case 'leaving':
                                transitionStyle = {
                                    transform: 'scale(0)',
                                    transition: ['transform'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
                                    transformOrigin: 'top left',
                                };
                                break;
                            case 'leaved':
                                transitionStyle = { display: 'none' };
                                break;
                            default:
                                break;
                        }
                        return (_jsx("li", Object.assign({ className: getClassName(`${dPrefix}upload__picture-item`, `${dPrefix}upload__picture-item--${file.status}`, {
                                'is-disabled': isLoading,
                            }), style: transitionStyle }, { children: file.status !== 'progress' ? (_jsxs(_Fragment, { children: [file.thumbUrl ? (_jsx("img", { className: `${dPrefix}upload__picture-preview`, src: file.thumbUrl, alt: file.name })) : (_jsxs(_Fragment, { children: [_jsx(FileTwoTone, { dSize: 28, dTheme: file.status === 'error' ? 'danger' : 'primary' }), _jsx("div", Object.assign({ className: `${dPrefix}upload__picture-name` }, { children: file.name }))] })), _jsx("div", Object.assign({ className: `${dPrefix}upload__picture-actions` }, { children: React.Children.map(actions, (action) => React.cloneElement(action, {
                                            __file: file,
                                            __defaultActions: dDefaultActions,
                                            __onRemove: () => {
                                                setRemoveUIDs((draft) => {
                                                    draft.push(file.uid);
                                                });
                                            },
                                        })) }))] })) : (_jsxs(_Fragment, { children: [_jsx("div", Object.assign({ className: `${dPrefix}upload__picture-text` }, { children: t('Upload', 'Uploading') })), isNumber(file.percent) && _jsx(DProgress, { dPercent: file.percent, dLineWidth: 2, dLabel: false })] })) })));
                    } }), file.uid));
            }), children] })));
}
